/**
 */
package org.gemoc.executionframework.xdsml_base.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import org.gemoc.executionframework.xdsml_base.util.Xdsml_baseAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class Xdsml_baseItemProviderAdapterFactory extends Xdsml_baseAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Xdsml_baseItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.gemoc.executionframework.xdsml_base.LanguageDefinition} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LanguageDefinitionItemProvider languageDefinitionItemProvider;

	/**
	 * This creates an adapter for a {@link org.gemoc.executionframework.xdsml_base.LanguageDefinition}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLanguageDefinitionAdapter() {
		if (languageDefinitionItemProvider == null) {
			languageDefinitionItemProvider = new LanguageDefinitionItemProvider(this);
		}

		return languageDefinitionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.gemoc.executionframework.xdsml_base.DomainModelProject} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DomainModelProjectItemProvider domainModelProjectItemProvider;

	/**
	 * This creates an adapter for a {@link org.gemoc.executionframework.xdsml_base.DomainModelProject}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDomainModelProjectAdapter() {
		if (domainModelProjectItemProvider == null) {
			domainModelProjectItemProvider = new DomainModelProjectItemProvider(this);
		}

		return domainModelProjectItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.gemoc.executionframework.xdsml_base.SiriusEditorProject} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SiriusEditorProjectItemProvider siriusEditorProjectItemProvider;

	/**
	 * This creates an adapter for a {@link org.gemoc.executionframework.xdsml_base.SiriusEditorProject}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSiriusEditorProjectAdapter() {
		if (siriusEditorProjectItemProvider == null) {
			siriusEditorProjectItemProvider = new SiriusEditorProjectItemProvider(this);
		}

		return siriusEditorProjectItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.gemoc.executionframework.xdsml_base.SiriusAnimatorProject} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SiriusAnimatorProjectItemProvider siriusAnimatorProjectItemProvider;

	/**
	 * This creates an adapter for a {@link org.gemoc.executionframework.xdsml_base.SiriusAnimatorProject}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSiriusAnimatorProjectAdapter() {
		if (siriusAnimatorProjectItemProvider == null) {
			siriusAnimatorProjectItemProvider = new SiriusAnimatorProjectItemProvider(this);
		}

		return siriusAnimatorProjectItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.gemoc.executionframework.xdsml_base.XTextEditorProject} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected XTextEditorProjectItemProvider xTextEditorProjectItemProvider;

	/**
	 * This creates an adapter for a {@link org.gemoc.executionframework.xdsml_base.XTextEditorProject}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createXTextEditorProjectAdapter() {
		if (xTextEditorProjectItemProvider == null) {
			xTextEditorProjectItemProvider = new XTextEditorProjectItemProvider(this);
		}

		return xTextEditorProjectItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.gemoc.executionframework.xdsml_base.TreeEditorProject} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TreeEditorProjectItemProvider treeEditorProjectItemProvider;

	/**
	 * This creates an adapter for a {@link org.gemoc.executionframework.xdsml_base.TreeEditorProject}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTreeEditorProjectAdapter() {
		if (treeEditorProjectItemProvider == null) {
			treeEditorProjectItemProvider = new TreeEditorProjectItemProvider(this);
		}

		return treeEditorProjectItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (languageDefinitionItemProvider != null) languageDefinitionItemProvider.dispose();
		if (domainModelProjectItemProvider != null) domainModelProjectItemProvider.dispose();
		if (siriusEditorProjectItemProvider != null) siriusEditorProjectItemProvider.dispose();
		if (siriusAnimatorProjectItemProvider != null) siriusAnimatorProjectItemProvider.dispose();
		if (xTextEditorProjectItemProvider != null) xTextEditorProjectItemProvider.dispose();
		if (treeEditorProjectItemProvider != null) treeEditorProjectItemProvider.dispose();
	}

}
